#include "hmg.ch"

FUNCTION Main

   DEFINE WINDOW Form_1 ;
	       AT 0,0 ;
          WIDTH 400 ;
          HEIGHT 200 ;
	       TITLE 'Calcular Años meses y días' ;
          MAIN ;
 	       ON INIT P_result()

      @010, 010 LABEL lbl_0 ;
              VALUE "Seleccione el rango de fechas" ;
              WIDTH 370 ;
              HEIGHT 25 ;
              CENTERALIGN ;
              FONT "TAHOMA" ;
              SIZE 11 ;
              BOLD

      @040,010 LABEL lbl_1 ;
              WIDTH 50 ;
              HEIGHT 20 ;
              VALUE "Desde" ;
              RIGHTALIGN

      @035,065 DATEPICKER Date_1 ;
              WIDTH 95 ;
              HEIGHT 22 ;
		        VALUE Date() - (365 * 10) ;
              RIGHTALIGN ;
              ON CHANGE P_Result()

      @040,180 LABEL lbl_2 ;
              WIDTH 50 ;
              HEIGHT 20 ;
              VALUE "Hasta" ;
              RIGHTALIGN

      @035,235 DATEPICKER Date_2 ;
              WIDTH 100 ;
              HEIGHT 22 ;
		        VALUE Date() ;
              RIGHTALIGN ;
              ON CHANGE P_Result()

      @075, 010 LABEL lbl_edad ;
              WIDTH 370 ;
              VALUE "Edad en años, meses y días" ;
              CENTERALIGN ;
              BOLD ;
              SIZE 10

      @100, 055 LABEL lbl_anio ;
              WIDTH 40 ;
              VALUE "Años" ;
              RIGHTALIGN

	   @095, 100 TEXTBOX text_Y ;
               VALUE '' ;
               WIDTH 35 ;
               RIGHTALIGN

      @100,145 LABEL lbl_meses ;
               WIDTH 40 ;
               VALUE "Meses" ;
               RIGHTALIGN

      @095,190 TEXTBOX text_M ;
               VALUE '' ;
               WIDTH 35 ;
               RIGHTALIGN

      @100,235 LABEL lbl_dias ;
               WIDTH 40 ;
               VALUE "Dias" ;
               RIGHTALIGN

	    @095,280 TEXTBOX text_D ;
               VALUE '' ;
               WIDTH 35 ;
               RIGHTALIGN

	    @125,100 TEXTBOX text_AMD ;
               VALUE '' ;
               WIDTH 200

   END WINDOW

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1
   RETURN

//----------------------------------------------------------------------------//
STATIC PROCEDURE P_result()
   form_1.text_AMD.value := CalculaAMD( Form_1.date_1.value, Form_1.date_2.value )
   retu nil

//----------------------------------------------------------------------------//
STATIC FUNCTION CalculaAMD(FechaInicio, FechaActual)
   local nDiaActual  := day( FechaActual)
   local nMesActual  := month(FechaActual)
   local nAnioActual := year(FechaActual)
   *******************************************************
   local nDiaInicio  := day(FechaInicio)
   local nMesInicio  := month(FechaInicio)
   local nAnioInicio := year(FechaInicio)
   *******************************************************
   local b           := 0
   local aFin
   local nAnios
   local nMeses
   local nDias
   local cRet       := ""

   if nMesActual == 2
      if (nAnioActual/4) == 0 .and. (nAnioActual/100) != 0 .or. (nAnioActual/400)=0
         b := 29
      else
         b := 28
      endif
   else
      b := {31,28,31,30,31,30,31,31,30,31,30,31}[nMesActual]
   endif

   if ((nAnioInicio > nAnioActual) .or. (nAnioInicio = nAnioActual .and. nMesInicio > nMesActual) .Or. (nAnioInicio = nAnioActual .and. nMesInicio = nMesActual .and. nDiaInicio > nDiaActual))
      MsgStop( "La fecha de inicio ha de ser anterior a la fecha Actual", "Error" )
   else
      if nMesInicio <= nMesActual
         nAnios := (nAnioActual - nAnioInicio )
         if nDiaInicio <= nDiaActual
             nMeses := (nMesActual - nMesInicio)
             nDias  := (nDiaActual - nDiaInicio)
         else
             if nMesActual == nMesInicio
                nAnios := (nAnios - 1)
             endif
             nMeses := (nMesActual - nMesInicio - 1 + 12)
             nDias  := b - (nDiaInicio - nDiaActual)
         endif
      else
         nAnios := nAnioActual - nAnioInicio - 1
         if nDiaInicio > nDiaActual
            nMeses := (nMesActual - nMesInicio - 1 + 12)
            nDias  := b - (nDiaInicio - nDiaActual)
         else
            nMeses := nMesActual - nMesInicio + 12
            nDias  := nDiaActual - nDiaInicio
         endif
      endif

      // Estos renglones son para el 'Test' solamente -----------
      Form_1.Text_Y.value := str(nAnios,3)                           //
      Form_1.Text_M.value := str(nMeses,3)                           //
      Form_1.Text_D.value := str(nDias ,3)                           //
      //------------------------------------------------------------------------

      /* Lo que realmente devuelve la funcion */
      cRet:=str(nAnios,3)+" año"+if(nAnios>1, "s "," ")+str(nMeses,3)+" mes"+;
         if(nMeses>1,"es ", " ")+str(nDias, 2 )+" dia"+if(nDias>1, "s.",".")
   endif
   RETURN( cRet )